import axios from 'axios';
import { API_URL_TRANSACTION } from '@/shared/api/api-url-transaction';
import { resultify } from '@/shared/lib/resultify';
import { NiceAxiosError } from '@/shared/@types/error';
import { 
  CashReceiptDetailParams,
  DetailResponse
} from '../model/types';
import { 
  useMutation,
  UseMutationOptions
} from '@tanstack/react-query';
import { getHeaderUserAgent } from '@/shared/constants/url';

export const cashReceiptDetail = (params: CashReceiptDetailParams) => {
  let headerOptions = {
    menuId: 32,
    apiType: 'SELECT'
  };
  let options = {
    headers: {
      'X-User-Agent': getHeaderUserAgent(headerOptions)
    }
  };
  return resultify(
    axios.post<DetailResponse>(API_URL_TRANSACTION.cashReceiptDetail(), params, options),
  );
};

export const useCashReceiptDetailMutation = (options?: UseMutationOptions<DetailResponse, NiceAxiosError, CashReceiptDetailParams>) => {
  const mutation = useMutation<DetailResponse, NiceAxiosError, CashReceiptDetailParams>({
    ...options,
    mutationFn: (params: CashReceiptDetailParams) => cashReceiptDetail(params),
  });

  return {
    ...mutation,
  };
};
